REM     *****        Logic Chip Tester Control Software        *****
REM     *****             (C) 1994 Paul Stenning               *****
REM
REM     *****     Source Code for Microsoft QuickBASIC V4.5    *****
REM     *****         and QBASIC (MS-DOS 5.0 and later)        *****
REM
REM
REM     *****        See README.TXT For Use Restrictions       *****


REM Version 1.00 - 30/05/94
REM Version 1.10 - 27/12/98  --  Patch to work with Windows 95

Init:
    REM $STATIC
    DIM PinTypes%(1 TO 24)
    DIM TestData%(1 TO 22, 1 TO 100)
    DIM EditPos%(1 TO 22)
    DIM SendData%(1 TO 23)
    DIM GetData%(1 TO 23)
    DIM PinMatch%(1 TO 24)
    DIM EditMatch%(1 TO 24)
    SCREEN 0
    WIDTH 80
    COLOR 7, 0
    CLS
    IF LEFT$(COMMAND$, 2) = "/?" THEN GOTO Help
    PRINT
    PRINT "Chip Tester Software Loading - Please Wait"
    ValidData% = 0
    ON ERROR GOTO DosError
    Temp% = 0
    SHELL "VER > CHIPTEST.TMP"
    OPEN "CHIPTEST.TMP" FOR INPUT AS #1
    DO UNTIL EOF(1) OR Temp% = 1
        LINE INPUT #1, Temp$
        Temp$ = LTRIM$(RTRIM$(Temp$))
        IF LEN(Temp$) > 0 THEN
            DOS = VAL(RIGHT$(Temp$, 5))
            IF DOS < 1 THEN DOS = 950
            Temp% = 1
        END IF
    LOOP
    CLOSE #1
    KILL "CHIPTEST.TMP"
    IF DOS < 3 THEN GOTO WrongDos
    ON ERROR GOTO 0
    GOSUB OpenCom
    Chip$ = UCASE$(COMMAND$)
    IF LEFT$(Chip$, 2) = "/1" OR LEFT$(Chip$, 2) = "/2" THEN
        Chip$ = RIGHT$(Chip$, LEN(Chip$) - 2)
    END IF
    Chip$ = LTRIM$(RTRIM$(Chip$))
    IF Chip$ <> "" THEN
        IF RIGHT$(Chip$, 4) <> ".CHP" THEN
            Chip$ = Chip$ + ".CHP"
        END IF
        GOTO AutoLoad
    END IF

MainMenu:
    CLS
    LOCATE 3, 20, 0, 8, 9
    COLOR 15
    PRINT "***  LOGIC CHIP TESTER - MAIN MENU  ***"
    COLOR 7
    LOCATE 6, 15
    PRINT "1  -  Create New Test Parameters"
    LOCATE 8, 15
    PRINT "2  -  Load Existing Test Parameters From Disk"
    LOCATE 10, 15
    PRINT "3  -  Edit Loaded Test Parameters (Test Sequence Only)"
    LOCATE 12, 15
    PRINT "4  -  Test Chip Once (Slow)"
    LOCATE 14, 15
    PRINT "5  -  Test Chip Once (Fast)"
    LOCATE 16, 15
    PRINT "6  -  Test Chip Repeatedly Until Failure"
    LOCATE 18, 15
    PRINT "7  -  Test Chip Repeatedly Until Pass"
    LOCATE 20, 13
    PRINT "Esc  -  Exit To DOS"
    LOCATE 25, 17
    COLOR 14
    PRINT "(C) 1994 Paul Stenning & Electronics in Action";
    COLOR 7
MenuLoop:
    DO
        Key$ = INKEY$
    LOOP UNTIL Key$ <> ""
    SELECT CASE Key$
        CASE "1"
            GOTO NewData
        CASE "2"
            GOTO LoadData
        CASE "3"
            IF ValidData% = 0 THEN
                LOCATE 23, 30
                COLOR 12
                PRINT "No Device Data Loaded"
                COLOR 7
                BEEP
            ELSE
                GOTO EditData
            END IF
        CASE "4"
            IF ValidData% = 0 THEN
                LOCATE 23, 30
                COLOR 12
                PRINT "No Device Data Loaded"
                COLOR 7
                BEEP
            ELSE
                Slow% = 1
                GOTO TestOnce
            END IF
        CASE "5"
            IF ValidData% = 0 THEN
                LOCATE 23, 30
                COLOR 12
                PRINT "No Device Data Loaded"
                COLOR 7
                BEEP
            ELSE
                Slow% = 0
                GOTO TestOnce
            END IF
        CASE "6"
            IF ValidData% = 0 THEN
                LOCATE 23, 30
                COLOR 12
                PRINT "No Device Data Loaded"
                COLOR 7
                BEEP
            ELSE
                GOTO TestFail
            END IF
        CASE "7"
            IF ValidData% = 0 THEN
                LOCATE 23, 30
                COLOR 12
                PRINT "No Device Data Loaded"
                COLOR 7
                BEEP
            ELSE
                GOTO TestPass
            END IF
        CASE CHR$(27)
            GOTO Quit
    END SELECT
    GOTO MenuLoop

TestOnce:
    GOSUB TestChipInit
    DeviceFail% = 0
    GOSUB TestChipMain
    LOCATE 21, 25
    COLOR 14
    PRINT "  Press Any Key To Continue  ";
    LOCATE 2, 56
    IF DeviceFail% = 1 THEN
        COLOR 12
        PRINT "*** DEVICE FAILED ***"
        BEEP
    ELSE
        COLOR 10
        PRINT "*** DEVICE PASSED ***"
    END IF
    DO
    LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

TestFail:
    GOSUB TestChipInit
    Slow% = 0
    DeviceFail% = 0
    TestCount% = 1
    DO
        COLOR 15
        LOCATE 2, 35
        PRINT "Test"; TestCount%
        GOSUB TestChipMain
        IF TestCount% < 32000 THEN
            TestCount% = TestCount% + 1
        END IF
    LOOP UNTIL DeviceFail% = 1 OR INKEY$ = CHR$(27)
    LOCATE 2, 56
    IF DeviceFail% = 1 THEN
        COLOR 12
        PRINT "*** DEVICE FAILED ***"
        BEEP
    ELSE
        COLOR 10
        PRINT "*** DEVICE PASSED ***"
    END IF
    DO: LOOP UNTIL INKEY$ = ""
    LOCATE 21, 25
    COLOR 15
    PRINT "  Press Any Key To Continue  ";
    DO
    LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

TestPass:
    GOSUB TestChipInit
    Slow% = 0
    TestCount% = 1
    DO
        DeviceFail% = 0
        COLOR 15
        LOCATE 2, 35
        PRINT "Test"; TestCount%
        GOSUB TestChipMain
        IF TestCount% < 32000 THEN
            TestCount% = TestCount% + 1
        END IF
    LOOP UNTIL DeviceFail% = 0 OR INKEY$ = CHR$(27)
    LOCATE 2, 56
    IF DeviceFail% = 1 THEN
        COLOR 12
        PRINT "*** DEVICE FAILED ***"
    ELSE
        COLOR 10
        PRINT "*** DEVICE PASSED ***"
        BEEP
    END IF
    DO: LOOP UNTIL INKEY$ = ""
    LOCATE 21, 25
    COLOR 15
    PRINT "  Press Any Key To Continue  ";
    DO
    LOOP UNTIL INKEY$ <> ""
    GOTO MainMenu

TestChipInit:
    CLS
    GOSUB Picture
    LOCATE 2, 5
    COLOR 15
    PRINT "Device Type = "; Chip$
    COLOR 7
    IF PinTypes%(Pin%) = 5 AND PinTypes%(Pin% / 2) = 6 THEN
        Offset% = 0
        LOCATE 22, 9
        PRINT "Place Device At Bottom Of Socket, And Set Switch To Position"; Pin%
    ELSE
        Offset% = 1
        FOR Count% = 1 TO Pin%
            IF PinTypes%(Count%) = 5 THEN VCCPin% = Count%
            IF PinTypes%(Count%) = 6 THEN GNDPin% = Count%
        NEXT
        LOCATE 20, 14
        PRINT "Place Device One Position Up From Bottom Of Socket.";
        LOCATE 21, 10
        PRINT "Set Switch To Position 24.  Link Pin 12 Of Socket To Pin"; GNDPin%;
        LOCATE 22, 12
        PRINT "Of Device, & Link Pin 24 Of Socket To Pin"; VCCPin%; "Of Device.";
    END IF
    FOR Count% = 1 TO Pin%
        IF Offset% = 0 THEN
            IF Count% <= Pin% / 2 THEN
                PinMatch%(Count%) = ((24 - Pin%) / 2) + Count%
            ELSE
                PinMatch%(Count%) = ((24 - Pin%) / 2) - 1 + Count%
            END IF
        ELSE
            IF Count% <= Pin% / 2 THEN
                PinMatch%(Count%) = ((24 - Pin%) / 2) - 1 + Count%
            ELSE
                PinMatch%(Count%) = ((24 - Pin%) / 2) + Count%
            END IF
        END IF
        GOSUB PinPosition
        SELECT CASE PinTypes%(Count%)
            CASE 1
                PRINT " Input"
            CASE 2
                PRINT " Output"
            CASE 3
                PRINT "+ Clock"
            CASE 4
                PRINT "- Clock"
            CASE 5
                PRINT "  VCC"
            CASE 6
                PRINT "  GND"
            CASE 7
                PRINT " Unused"
        END SELECT
    NEXT
    GOSUB PinConv
    FOR Count% = 1 TO Pin%
        SELECT CASE PinTypes%(Count%)
            CASE 2, 4, 5
                SendData%(PinMatch%(Count%)) = 1
            CASE 1, 3, 6
                SendData%(PinMatch%(Count%)) = 0
        END SELECT
    NEXT
    GOSUB SendData
    LOCATE 24, 27
    COLOR 14
    PRINT "Press Any Key To Continue";
    DO
    LOOP UNTIL INKEY$ <> ""
    LOCATE 20, 1
    PRINT SPACE$(400);
    COLOR 15
    LOCATE 2, 56
    PRINT "Testing At Step 0"
    COLOR 14
    LOCATE 21, 25
    PRINT "Testing Device - Please Wait"
    COLOR 10
    LOCATE 24, 12
    PRINT "Green = Logic 0";
    COLOR 12
    LOCATE 24, 32
    PRINT "Red = Logic 1";
    COLOR 11
    LOCATE 24, 51
    PRINT "Blue = Clock Pulses";
    RETURN

PinConv:
    PosCount% = 1
    IF PosPin% > 0 OR NegPin% > 0 THEN
        FOR Count% = 1 TO Pin%
            IF PinTypes%(Count%) = 3 OR PinTypes%(Count%) = 4 THEN
                EditMatch%(Count%) = PosCount%
                PosCount% = PosCount% + 1
            END IF
        NEXT
    END IF
    IF InPin% > 0 THEN
        FOR Count% = 1 TO Pin%
            IF PinTypes%(Count%) = 1 THEN
                EditMatch%(Count%) = PosCount%
                PosCount% = PosCount% + 1
            END IF
        NEXT
    END IF
    FOR Count% = 1 TO Pin%
        IF PinTypes%(Count%) = 2 THEN
            EditMatch%(Count%) = PosCount%
            PosCount% = PosCount% + 1
        END IF
    NEXT
    RETURN

TestChipMain:
    FOR DataStep% = 1 TO TestStep%
        LOCATE 2, 71
        COLOR 15
        PRINT DataStep%
        IF PosPin% + NegPin% > 0 THEN
            FOR Count% = 1 TO Pin%
                SELECT CASE PinTypes%(Count%)
                    CASE 3
                        IF TestData%(EditMatch%(Count%), DataStep%) > 0 THEN
                            GOSUB PinPosition
                            COLOR 11
                            PRINT "+ Clock"
                            FOR Clock% = 1 TO TestData%(EditMatch%(Count%), DataStep%)
                                SendData%(PinMatch%(Count%)) = 1
                                GOSUB SendData
                                SendData%(PinMatch%(Count%)) = 0
                                GOSUB SendData
                                GOSUB PinPosition
                                IF Count% > Pin% / 2 THEN
                                    LOCATE CSRLIN, POS(0) + 8
                                ELSE
                                    LOCATE CSRLIN, POS(0) - 6
                                END IF
                                PRINT Clock%;
                                IF Slow% = 1 THEN
                                    Time = TIMER + .05
                                ELSE
                                    Time = TIMER + .01
                                END IF
                                DO: LOOP UNTIL TIMER >= Time OR TIMER < 1
                            NEXT
                            IF Slow% = 1 THEN
                                Time = TIMER + .3
                                DO
                                LOOP UNTIL TIMER >= Time OR TIMER < 1
                            END IF
                            GOSUB PinPosition
                            IF Count% > Pin% / 2 THEN
                                LOCATE CSRLIN, POS(0) + 8
                            ELSE
                                LOCATE CSRLIN, POS(0) - 6
                            END IF
                            PRINT SPACE$(6)
                        END IF
                    CASE 4
                        IF TestData%(EditMatch%(Count%), DataStep%) > 0 THEN
                            GOSUB PinPosition
                            COLOR 11
                            PRINT "- Clock"
                            FOR Clock% = 1 TO TestData%(EditMatch%(Count%), DataStep%)
                                SendData%(PinMatch%(Count%)) = 0
                                GOSUB SendData
                                SendData%(PinMatch%(Count%)) = 1
                                GOSUB SendData
                                GOSUB PinPosition
                                IF Count% > Pin% / 2 THEN
                                    LOCATE CSRLIN, POS(0) + 8
                                ELSE
                                    LOCATE CSRLIN, POS(0) - 6
                                END IF
                                PRINT Clock%;
                                IF Slow% = 1 THEN
                                    Time = TIMER + .05
                                ELSE
                                    Time = TIMER + .01
                                END IF
                                DO: LOOP UNTIL TIMER >= Time OR TIMER < 1
                            NEXT
                            IF Slow% = 1 THEN
                                Time = TIMER + .3
                                DO
                                LOOP UNTIL TIMER >= Time OR TIMER < 1
                            END IF
                            GOSUB PinPosition
                            IF Count% > Pin% / 2 THEN
                                LOCATE CSRLIN, POS(0) + 8
                            ELSE
                                LOCATE CSRLIN, POS(0) - 6
                            END IF
                            PRINT SPACE$(6)
                        END IF
                END SELECT
            NEXT
        END IF
        LoopFail% = 0
        FOR Count% = 1 TO Pin%
            SELECT CASE PinTypes%(Count%)
                CASE 1
                    SendData%(PinMatch%(Count%)) = TestData%(EditMatch%(Count%), DataStep%) - 1
                CASE 2, 4, 5
                    SendData%(PinMatch%(Count%)) = 1
                CASE 3, 6
                    SendData%(PinMatch%(Count%)) = 0
            END SELECT
        NEXT
        GOSUB SendData
        GOSUB GetData
        FOR Count% = 1 TO Pin%
            GOSUB PinPosition
            IF PinTypes%(Count%) = 1 THEN
                IF GetData%(PinMatch%(Count%)) = 1 THEN
                    COLOR 12
                    PRINT " Input";
                END IF
                IF GetData%(PinMatch%(Count%)) = 0 THEN
                    COLOR 10
                    PRINT " Input";
                END IF
            END IF
            IF PinTypes%(Count%) = 2 THEN
                IF GetData%(PinMatch%(Count%)) = 1 THEN
                    COLOR 12
                    PRINT " Output";
                END IF
                IF GetData%(PinMatch%(Count%)) = 0 THEN
                    COLOR 10
                    PRINT " Output";
                END IF
            END IF
            IF PinTypes%(Count%) = 3 THEN
                IF GetData%(PinMatch%(Count%)) = 1 THEN
                    COLOR 12
                    PRINT "+ Clock";
                END IF
                IF GetData%(PinMatch%(Count%)) = 0 THEN
                    COLOR 10
                    PRINT "+ Clock";
                END IF
            END IF
            IF PinTypes%(Count%) = 4 THEN
                IF GetData%(PinMatch%(Count%)) = 1 THEN
                    COLOR 12
                    PRINT "- Clock";
                END IF
                IF GetData%(PinMatch%(Count%)) = 0 THEN
                    COLOR 10
                    PRINT "- Clock";
                END IF
            END IF
            IF (PinTypes%(Count%) = 1 OR PinTypes%(Count%) = 2) THEN
                IF TestData%(EditMatch%(Count%), DataStep%) <> 0 THEN
                    IF GetData%(PinMatch%(Count%)) <> TestData%(EditMatch%(Count%), DataStep%) - 1 THEN
                        LoopFail% = 1
                        DeviceFail% = 1
                    END IF
                END IF
            END IF
            IF PinTypes%(Count%) = 3 AND GetData%(PinMatch%(Count%)) <> 0 THEN
                LoopFail% = 1
                DeviceFail% = 1
            END IF
            IF PinTypes%(Count%) = 4 AND GetData%(PinMatch%(Count%)) <> 1 THEN
                LoopFail% = 1
                DeviceFail% = 1
            END IF
        NEXT
        LOCATE 2, 31
        IF Slow% = 1 THEN
            IF LoopFail% = 1 THEN
                COLOR 12
                PRINT "This Step Failed"
            ELSE
                COLOR 10
                PRINT "This Step Passed"
            END IF
            Time = TIMER + 1
            DO
            LOOP UNTIL TIMER >= Time OR TIMER < 1
        END IF
    NEXT
    COLOR 7
    RETURN

NewData:
    CLS
    LOCATE 2, 17
    INPUT "Enter Device Number (Max 8 Characters) ", Chip$
    IF Chip$ = "" THEN GOTO MainMenu
    Abort% = 0
    IF LEN(Chip$) > 8 THEN Abort% = 1
    Chip$ = UCASE$(Chip$)
    Bad$ = " []^*?|\#:;<>,./'=+`" + CHR$(34)
    FOR Temp% = 1 TO LEN(Bad$)
        IF INSTR(Chip$, MID$(Bad$, Temp%, 1)) > 0 THEN
            Abort% = 1
            EXIT FOR
        END IF
    NEXT
    IF Abort% = 1 THEN
        LOCATE 22, 18
        COLOR 12
        PRINT "Invalid File Name - Press Any Key To Continue"
        BEEP
        DO
        LOOP UNTIL INKEY$ <> ""
        GOTO MainMenu
    END IF
    LOCATE 4, 8
    INPUT "Enter Number of Pins on Device (14, 16, 18, 20, 22 or 24) ", Pin$
    SELECT CASE Pin$
        CASE "14", "16", "18", "20", "22", "24"
            Pin% = VAL(Pin$)
        CASE ELSE
            GOTO MainMenu
    END SELECT
    Abort% = 0
    GOSUB EditPinFunctions
    IF Abort% = 1 THEN GOTO MainMenu
    TestStep% = 1
    ERASE TestData%
    CLS
    GOSUB TopLine
    GOSUB DivideLines
    GOSUB EditTestRoutine
    ValidData% = 1
    GOSUB SaveData
    GOTO MainMenu

EditData:
    CLS
    GOSUB TopLine
    GOSUB DivideLines
    Temp% = TestStep%
    IF Temp% > 22 THEN Temp% = 22
    FOR DataStep% = 1 TO Temp%
        Row% = DataStep% + 3
        PosCount% = 1
        GOSUB DataLine
    NEXT
    GOSUB EditTestRoutine
    ValidData% = 1
    GOSUB SaveData
    GOTO MainMenu

EditTestRoutine:
    Row% = 4
    PosCount% = 1
    DataStep% = 1
    Abort% = 0
    GOSUB DataLine
    IF PosCount% <= PosPin% + NegPin% THEN
        LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
    ELSE
        LOCATE Row%, EditPos%(PosCount%)
    END IF
    DO UNTIL Abort% = 1
        DO
            Key$ = UCASE$(INKEY$)
        LOOP UNTIL Key$ <> ""
        SELECT CASE Key$
            CASE CHR$(0) + CHR$(80)
                IF DataStep% < 100 THEN
                    DataStep% = DataStep% + 1
                    IF TestStep% < DataStep% THEN TestStep% = DataStep%
                    IF Row% < 25 THEN
                        Row% = Row% + 1
                        GOSUB DataLine
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    ELSE
                        DataTemp% = DataStep%
                        DataStep% = DataStep% - 21
                        FOR Row% = 4 TO 25
                            GOSUB DataLine
                            DataStep% = DataStep% + 1
                        NEXT
                        Row% = 25
                        DataStep% = DataTemp%
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    END IF
                END IF
            CASE CHR$(0) + CHR$(72)
                IF DataStep% > 1 THEN
                    DataStep% = DataStep% - 1
                    IF Row% > 4 THEN
                        Row% = Row% - 1
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    ELSE
                        DataTemp% = DataStep%
                        FOR Row% = 4 TO 25
                            IF DataStep% <= TestStep% THEN
                                GOSUB DataLine
                                DataStep% = DataStep% + 1
                            END IF
                        NEXT
                        Row% = 4
                        DataStep% = DataTemp%
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    END IF
                END IF
            CASE CHR$(13)
                PosCount% = 1
                IF DataStep% < 100 THEN
                    DataStep% = DataStep% + 1
                    IF TestStep% < DataStep% THEN TestStep% = DataStep%
                    IF Row% < 25 THEN
                        Row% = Row% + 1
                        GOSUB DataLine
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    ELSE
                        DataTemp% = DataStep%
                        DataStep% = DataStep% - 21
                        FOR Row% = 4 TO 25
                            GOSUB DataLine
                            DataStep% = DataStep% + 1
                        NEXT
                        Row% = 25
                        DataStep% = DataTemp%
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    END IF
                END IF
            CASE CHR$(0) + CHR$(83)
                IF DataStep% = TestStep% AND TestStep% > 1 THEN
                    FOR Temp% = 1 TO EditPin%
                        TestData%(Temp%, DataStep%) = 0
                    NEXT
                    TestStep% = TestStep% - 1
                    DataStep% = TestStep%
                    PosCount% = 1
                    LOCATE Row%, 1
                    PRINT SPACE$(80);
                    Row% = Row% - 1
                    GOSUB DivideLines
                    GOSUB DataLine
                    IF PosCount% <= PosPin% + NegPin% THEN
                        LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                    ELSE
                        LOCATE Row%, EditPos%(PosCount%)
                    END IF

                END IF
        END SELECT
        IF PosCount% <= PosPin% + NegPin% THEN
            SELECT CASE Key$
                CASE "0" TO "9"
                    Value$ = STR$(TestData%(PosCount%, DataStep%))
                    Value$ = RTRIM$(Value$)
                    IF PosPin% + NegPin% > 1 THEN
                        IF LEN(Value$) < 3 THEN
                            Value$ = Value$ + Key$
                            TestData%(PosCount%, DataStep%) = VAL(Value$)
                            LOCATE Row%, EditPos%(PosCount%) - 1
                            PRINT TestData%(PosCount%, DataStep%);
                            LOCATE Row%, POS(0) - 1
                        ELSE
                            BEEP
                        END IF
                    ELSE
                        IF LEN(Value$) < 5 THEN
                            Value$ = Value$ + Key$
                            TestData%(PosCount%, DataStep%) = VAL(Value$)
                            LOCATE Row%, EditPos%(PosCount%) - 1
                            PRINT TestData%(PosCount%, DataStep%);
                            LOCATE Row%, POS(0) - 1
                        ELSE
                            BEEP
                        END IF
                    END IF
                CASE CHR$(8)
                    Value$ = STR$(TestData%(PosCount%, DataStep%))
                    Value$ = RTRIM$(Value$)
                    IF LEN(Value$) > 1 THEN
                        Value$ = LEFT$(Value$, LEN(Value$) - 1)
                        Value$ = Value$ + Key$
                        TestData%(PosCount%, DataStep%) = VAL(Value$)
                        LOCATE Row%, EditPos%(PosCount%) - 1
                        PRINT TestData%(PosCount%, DataStep%);
                        LOCATE Row%, POS(0) - 1
                    ELSE
                        BEEP
                    END IF
                CASE CHR$(9), CHR$(0) + CHR$(77)
                    IF PosCount% < EditPin% THEN
                        PosCount% = PosCount% + 1
                        IF PosCount% <= PosPin% + NegPin% THEN
                            LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                        ELSE
                            LOCATE Row%, EditPos%(PosCount%)
                        END IF
                    END IF
                CASE CHR$(0) + CHR$(75)
                    IF PosCount% > 1 THEN
                        PosCount% = PosCount% - 1
                        LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
                    END IF
                CASE CHR$(27)
                    Abort% = 1
            END SELECT
        ELSE
            SELECT CASE Key$
                CASE "1"
                    TestData%(PosCount%, DataStep%) = 2
                    PRINT "1";
                    IF PosCount% < EditPin% THEN
                        PosCount% = PosCount% + 1
                    END IF
                CASE "0"
                    TestData%(PosCount%, DataStep%) = 1
                    PRINT "0";
                    IF PosCount% < EditPin% THEN
                        PosCount% = PosCount% + 1
                    END IF
                CASE "X"
                    IF PosCount% > InPin% + PosPin% + NegPin% THEN
                        TestData%(PosCount%, DataStep%) = 0
                        PRINT "X";
                        IF PosCount% < EditPin% THEN
                            PosCount% = PosCount% + 1
                        END IF
                    END IF
                CASE " "
                    TestData%(PosCount%, DataStep%) = TestData%(PosCount%, DataStep%) + 1
                    IF TestData%(PosCount%, DataStep%) > 2 THEN
                        TestData%(PosCount%, DataStep%) = 0
                    END IF
                    IF PosCount% <= InPin% + PosPin% + NegPin% THEN
                        IF TestData%(PosCount%, DataStep%) = 0 THEN
                            TestData%(PosCount%, DataStep%) = 1
                        END IF
                    END IF
                    SELECT CASE TestData%(PosCount%, DataStep%)
                        CASE 0
                            PRINT "X";
                        CASE 1
                            PRINT "0";
                        CASE 2
                            PRINT "1";
                    END SELECT
                CASE CHR$(9), CHR$(0) + CHR$(77)
                    IF PosCount% < EditPin% THEN
                        PosCount% = PosCount% + 1
                    END IF
                CASE CHR$(0) + CHR$(75)
                    IF PosCount% > 1 THEN
                        PosCount% = PosCount% - 1
                    END IF
                CASE CHR$(27)
                    Abort% = 1
            END SELECT
            IF PosCount% <= PosPin% + NegPin% THEN
                LOCATE Row%, EditPos%(PosCount%) + LEN(STR$(TestData%(PosCount%, DataStep%))) - 1
            ELSE
                LOCATE Row%, EditPos%(PosCount%)
            END IF
        END IF
    LOOP
    LOCATE , , 0
    RETURN

TopLine:
    LOCATE 1, 1
    PRINT "    "; SPACE$(75);
    LOCATE 2, 1
    PRINT "    "; SPACE$(75);
    COLOR 14
    Position% = 6
    PosCount% = 1
    IF PosPin% > 0 OR NegPin% > 0 THEN
        FOR Count% = 1 TO Pin%
            IF PinTypes%(Count%) = 3 OR PinTypes%(Count%) = 4 THEN
                LOCATE 2, Position%
                PRINT Count%;
                EditPos%(PosCount%) = Position% + 1
                PosCount% = PosCount% + 1
                Position% = Position% + 3
            END IF
        NEXT
        Divider1% = Position% + 3
        Position% = Divider1% + 1
    ELSE
        Divider1% = 0
    END IF
    IF InPin% > 0 THEN
        FOR Count% = 1 TO Pin%
            IF PinTypes%(Count%) = 1 THEN
                LOCATE 2, Position%
                PRINT Count%;
                EditPos%(PosCount%) = Position% + 1
                PosCount% = PosCount% + 1
                Position% = Position% + 3
            END IF
        NEXT
        Divider2% = Position% + 3
        Position% = Divider2% + 1
    ELSE
        Divider2% = 0
    END IF
    FOR Count% = 1 TO Pin%
        IF PinTypes%(Count%) = 2 THEN
            LOCATE 2, Position%
            PRINT Count%;
            EditPos%(PosCount%) = Position% + 1
            PosCount% = PosCount% + 1
            Position% = Position% + 3
        END IF
    NEXT
    IF Position% > 80 THEN Position% = 80
    COLOR 15
    LOCATE 2, 1
    PRINT "STEP";
    LOCATE 1, 7
    IF Divider1% <> 0 THEN
        PRINT "CLOCKS";
        IF Divider2% <> 0 THEN
            LOCATE 1, Divider1% + 2
            PRINT "INPUTS";
        END IF
    ELSE
        PRINT "INPUTS";
    END IF
    IF Divider2% > 71 THEN
        LOCATE 1, 78
        PRINT "OUT";
    ELSE
        IF Divider2% <> 0 THEN
            LOCATE 1, Divider2% + 2
        ELSE
            LOCATE 1, Divider1% + 2
        END IF
        PRINT "OUTPUTS";
    END IF
    COLOR 7
    LOCATE 3, 1
    PRINT "";
    FOR Count% = 6 TO Position%
        PRINT "";
    NEXT
    IF Divider1% <> 0 THEN
        LOCATE 1, Divider1%
        PRINT "";
        LOCATE 2, Divider1%
        PRINT "";
        LOCATE 3, Divider1%
        PRINT "";
    END IF
    IF Divider2% <> 0 THEN
        LOCATE 1, Divider2%
        PRINT "";
        LOCATE 2, Divider2%
        PRINT "";
        LOCATE 3, Divider2%
        PRINT "";
    END IF
    LOCATE 4, 1
    RETURN

DivideLines:
    FOR Count% = 4 TO 25
        LOCATE Count%, 5
        PRINT "";
        IF Divider1% <> 0 THEN
            LOCATE Count%, Divider1%
            PRINT "";
        END IF
        IF Divider2% <> 0 THEN
            LOCATE Count%, Divider2%
            PRINT "";
        END IF
    NEXT
    RETURN

DataLine:
    LOCATE Row%, 1, 0
    PRINT LTRIM$(STR$(DataStep%)); " ";
    FOR Count% = 1 TO EditPin%
        SELECT CASE Count%
            CASE IS <= (PosPin% + NegPin%)
                LOCATE Row%, EditPos%(Count%) - 1
                PRINT TestData%(Count%, DataStep%);
                IF PosPin% + NegPin% = 1 THEN
                    PRINT SPACE$(5 - LEN(STR$(TestData%(Count%, DataStep%))));
                END IF
            CASE (PosPin% + NegPin% + 1) TO (PosPin% + NegPin% + InPin%)
                LOCATE Row%, EditPos%(Count%)
                SELECT CASE TestData%(Count%, DataStep%)
                    CASE 0
                        TestData%(Count%, DataStep%) = 1
                        PRINT "0";
                    CASE 1
                        PRINT "0";
                    CASE 2
                        PRINT "1";
                END SELECT
            CASE IS > (PosPin% + NegPin% + InPin%)
                LOCATE Row%, EditPos%(Count%)
                SELECT CASE TestData%(Count%, DataStep%)
                    CASE 0
                        PRINT "X";
                    CASE 1
                        PRINT "0";
                    CASE 2
                        PRINT "1";
                END SELECT
        END SELECT
    NEXT
    LOCATE , , 1
    RETURN

SaveData:
    LOCATE 23, 27
    COLOR 14
    PRINT "  Save Device Data [Y/N] ?  ";
    COLOR 7
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ = "Y" OR Key$ = "N" OR Key$ = CHR$(27)
    IF Key$ <> "Y" THEN RETURN
    LOCATE 23, 29
    COLOR 14
    PRINT "Saving Device Data File "
    COLOR 7
    ON ERROR GOTO SaveError
    OPEN Chip$ + ".CHP" FOR OUTPUT AS #1
    PRINT #1, "*** CHIP TESTER DEVICE FILE"
    PRINT #1, "#"
    PRINT #1, "#"
    PRINT #1, "*** PIN COUNT"
    PRINT #1, Pin%
    PRINT #1, InPin%
    PRINT #1, OutPin%
    PRINT #1, PosPin%
    PRINT #1, NegPin%
    PRINT #1, EditPin%
    PRINT #1, "*** PIN TYPES"
    FOR Count% = 1 TO Pin%
        PRINT #1, PinTypes%(Count%)
    NEXT
    PRINT #1, "*** TEST DATA"
    PRINT #1, TestStep%
    FOR Count% = 1 TO TestStep%
        FOR Temp% = 1 TO EditPin%
            PRINT #1, TestData%(Temp%, Count%);
        NEXT
        PRINT #1,
    NEXT
    PRINT #1, "*** END"
    CLOSE #1
    ON ERROR GOTO 0
    RETURN

Picture:
    COLOR 14
    LOCATE 12 - INT(Pin% / 4), 33
    PRINT "Ŀ"
    FOR Count% = 1 TO Pin% / 2 STEP 1
        IF Count% < 10 THEN
            LOCATE , 29
        ELSE
            LOCATE , 28
        END IF
        PRINT Count%; "Ĵ          "; Pin% - Count% + 1
    NEXT
    LOCATE , 33
    PRINT ""
    COLOR 7
    RETURN

EditPinFunctions:
    GOSUB Picture
    LOCATE 22, 12
    PRINT "1 = Input   2 = Output   3 = +ve Clock   4 = -ve Clock"
    LOCATE 23, 25
    PRINT "5 = VCC   6 = GND   7 = Unused"
    VCC% = 0
    GND% = 0
    InPin% = 0
    OutPin% = 0
    PosPin% = 0
    NegPin% = 0
    FOR Count% = 1 TO Pin%
        LOCATE 20, 18
        PRINT "Enter Function of Pin"; Count%; "From Options Below"
        GOSUB PinPosition
        COLOR 15
        PRINT "  ?"
        DO
            Key$ = INKEY$
        LOOP UNTIL Key$ <> ""
        SELECT CASE Key$
            CASE "1"
                PinTypes%(Count%) = 1
                GOSUB PinPosition
                PRINT " Input"
                InPin% = InPin% + 1
            CASE "2"
                PinTypes%(Count%) = 2
                GOSUB PinPosition
                PRINT " Output"
                OutPin% = OutPin% + 1
            CASE "3"
                PinTypes%(Count%) = 3
                GOSUB PinPosition
                PRINT "+ Clock"
                PosPin% = PosPin% + 1
            CASE "4"
                PinTypes%(Count%) = 4
                GOSUB PinPosition
                PRINT "- Clock"
                NegPin% = NegPin% + 1
            CASE "5"
                IF VCC% = 0 THEN
                    PinTypes%(Count%) = 5
                    VCCPin% = Count%
                    GOSUB PinPosition
                    PRINT "  VCC"
                    VCC% = 1
                ELSE
                    BEEP
                    Count% = Count% - 1
                END IF
            CASE "6"
                IF GND% = 0 THEN
                    PinTypes%(Count%) = 6
                    GNDPin% = Count%
                    GOSUB PinPosition
                    PRINT "  GND"
                    GND% = 1
                ELSE
                    BEEP
                    Count% = Count% - 1
                END IF
            CASE "7"
                PinTypes%(Count%) = 7
                GOSUB PinPosition
                PRINT " Unused"
            CASE CHR$(27)
                Abort% = 1
                COLOR 7
                EXIT FOR
            CASE ELSE
                Count% = Count% - 1
        END SELECT
        COLOR 7
    NEXT
    IF Abort% = 1 THEN RETURN
    LOCATE 20, 18
    PRINT SPACE$(44)
    LOCATE 23, 25
    PRINT SPACE$(40)
    LOCATE 22, 12
    IF VCC% = 0 OR GND% = 0 OR OutPin% = 0 OR (InPin% = 0 AND PosPin% = 0 AND NegPin% = 0) THEN
        BEEP
        COLOR 12
        PRINT "Pin Functions Do Not Make Sense - Any Key To Try Again"
        COLOR 7
        DO
        LOOP UNTIL INKEY$ <> ""
        FOR Count% = 5 TO 18
            LOCATE Count%, 15
            PRINT SPACE$(50)
        NEXT
        GOTO EditPinFunctions
    END IF
    IF Pin% > 20 AND (VCCPin% <> Pin% OR GNDPin% <> (Pin% / 2)) THEN
        BEEP
        COLOR 12
        PRINT "Power Pins Cannot Be Accomodated, Any Key To Try Again"
        COLOR 7
        DO
        LOOP UNTIL INKEY$ <> ""
        FOR Count% = 5 TO 18
            LOCATE Count%, 15
            PRINT SPACE$(50)
        NEXT
        GOTO EditPinFunctions
    END IF
    PRINT SPACE$(19); "All Correct [Y/N]"; SPACE$(19)
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ = "Y" OR Key$ = "N" OR Key$ = CHR$(27)
    SELECT CASE Key$
        CASE "N"
            FOR Count% = 5 TO 18
                LOCATE Count%, 15
                PRINT SPACE$(50)
            NEXT
            GOTO EditPinFunctions
        CASE CHR$(27)
            Abort% = 1
        END SELECT
    LOCATE 22, 31
    PRINT SPACE$(18)
    EditPin% = InPin% + OutPin% + PosPin% + NegPin%
    RETURN

PinPosition:
    IF Count% > (Pin% / 2) THEN
        LOCATE 13 - INT(Pin% / 4) + (Pin% - Count%), 53
    ELSE
        LOCATE 12 - INT(Pin% / 4) + Count%, 19
    END IF
    RETURN

LoadData:
    CLS
    COLOR 14
    LOCATE 23, 25
    PRINT "Reading Devices - Please Wait";
    LOCATE 1, 1
    COLOR 7
    ON ERROR GOTO LoadError
    IF DOS >= 5 THEN
        SHELL "DIR *.CHP /-P /-W /ON > CHIPTEST.TMP"
    ELSE
        SHELL "DIR *.CHP > CHIPTEST.TMP"
    END IF
    OPEN "CHIPTEST.TMP" FOR INPUT AS #1
    Count% = 0
    DO UNTIL EOF(1)
        LINE INPUT #1, Temp$
        IF LEFT$(Temp$, 1) <> " " AND LEN(Temp$) <> 0 THEN
            PRINT LEFT$(Temp$, 8); "  ";
            Count% = Count% + 1
            IF Count% = 168 THEN
                LOCATE 23, 25
                COLOR 14
                PRINT " Press Any Key For Next Part "
                COLOR 7
                DO
                LOOP UNTIL INKEY$ <> ""
                Count% = 0
                CLS
            END IF
        END IF
    LOOP
    CLOSE #1
    KILL "CHIPTEST.TMP"
    LOCATE 23, 25
    COLOR 14
    INPUT "Enter Name Of Device To Load ", Temp$
    IF Temp$ = "" THEN GOTO MainMenu
    Chip$ = UCASE$(Temp$)
    IF RIGHT$(Chip$, 4) <> ".CHP" THEN Chip$ = Chip$ + ".CHP"
    ERASE TestData%
    ValidData% = 0
    LOCATE 23, 25
    COLOR 14
    PRINT "    Loading Device Data File            "
    COLOR 7
AutoLoad:
    ON ERROR GOTO LoadError
    OPEN Chip$ FOR INPUT AS #1
    INPUT #1, Temp$
    IF Temp$ <> "*** CHIP TESTER DEVICE FILE" THEN ERROR 255
    INPUT #1, Temp$
    INPUT #1, Temp$
    INPUT #1, Temp$
    IF Temp$ <> "*** PIN COUNT" THEN ERROR 255
    INPUT #1, Pin%
    INPUT #1, InPin%
    INPUT #1, OutPin%
    INPUT #1, PosPin%
    INPUT #1, NegPin%
    INPUT #1, EditPin%
    INPUT #1, Temp$
    IF Temp$ <> "*** PIN TYPES" THEN ERROR 255
    FOR Count% = 1 TO Pin%
        INPUT #1, PinTypes%(Count%)
    NEXT
    INPUT #1, Temp$
    IF Temp$ <> "*** TEST DATA" THEN ERROR 255
    INPUT #1, TestStep%
    FOR Count% = 1 TO TestStep%
        FOR Temp% = 1 TO EditPin%
            INPUT #1, TestData%(Temp%, Count%)
        NEXT
    NEXT
    INPUT #1, Temp$
    IF Temp$ <> "*** END" THEN ERROR 255
    CLOSE #1
    ON ERROR GOTO 0
    Chip$ = LEFT$(Chip$, LEN(Chip$) - 4)
    ValidData% = 1
    GOTO MainMenu

SendData:
    Word1% = 0
    Word2% = 0
    Word3% = 0
    Word4% = 0
    Word5% = 0
    Word6% = 0
    FOR Temp% = 23 TO 1 STEP -1
        SELECT CASE Temp%
            CASE 1 TO 4
                Word1% = 2 * Word1% + SendData%(Temp%)
            CASE 5 TO 8
                Word2% = 2 * Word2% + SendData%(Temp%)
            CASE 9 TO 12
                Word3% = 2 * Word3% + SendData%(Temp%)
            CASE 13 TO 16
                Word4% = 2 * Word4% + SendData%(Temp%)
            CASE 17 TO 20
                Word5% = 2 * Word5% + SendData%(Temp%)
            CASE 21 TO 23
                Word6% = 2 * Word6% + SendData%(Temp%)
        END SELECT
    NEXT
    ON ERROR GOTO GetByteError
    PRINT #2, CHR$(Word1% + &H0);
    PRINT #2, CHR$(Word2% + &H10);
    PRINT #2, CHR$(Word3% + &H20);
    PRINT #2, CHR$(Word4% + &H30);
    PRINT #2, CHR$(Word5% + &H40);
    PRINT #2, CHR$(Word6% + &H50);
    ON ERROR GOTO 0
    RETURN

GetByte:
    ON ERROR GOTO GetByteError
    Timeout = TIMER + .1
    DO WHILE EOF(2) AND Timeout > TIMER AND TIMER > 1
    LOOP
    IF NOT EOF(2) THEN
        Temp$ = INPUT$(1, #2)
    ELSE
        ERROR 255
    END IF
    ON ERROR GOTO 0
    RETURN

GetData:
    PRINT #2, CHR$(&H70);
    GOSUB GetByte
    Word1% = ASC(Temp$)
    PRINT #2, CHR$(&H71);
    GOSUB GetByte
    Word2% = ASC(Temp$)
    PRINT #2, CHR$(&H72);
    GOSUB GetByte
    Word3% = ASC(Temp$)
    IF Word3% >= 128 THEN
        Word3% = Word3% - 128
    END IF
    FOR Count% = 7 TO 0 STEP -1
        IF Word1% >= (2 ^ Count%) THEN
            Word1% = Word1% - (2 ^ Count%)
            GetData%(1 + Count%) = 1
        ELSE
            GetData%(1 + Count%) = 0
        END IF
        IF Word2% >= (2 ^ Count%) THEN
            Word2% = Word2% - (2 ^ Count%)
            GetData%(9 + Count%) = 1
        ELSE
            GetData%(9 + Count%) = 0
        END IF
        IF Count% <> 7 THEN
            IF Word3% >= (2 ^ Count%) THEN
                Word3% = Word3% - (2 ^ Count%)
                GetData%(17 + Count%) = 1
            ELSE
                GetData%(17 + Count%) = 0
            END IF
        END IF
    NEXT
    RETURN

OpenCom:
    ON ERROR GOTO OpenError
    IF LEFT$(COMMAND$, 2) = "/2" THEN
        OPEN "COM2:9600,N,8,1,CS0,CD0,DS0" FOR RANDOM AS #2 LEN = 1
    ELSE
        OPEN "COM1:9600,N,8,1,CS0,CD0,DS0" FOR RANDOM AS #2 LEN = 1
    END IF
    ON ERROR GOTO 0
    RETURN

OpenError:
    CLOSE
    COLOR 7
    CLS
    LOCATE 2, 1
    COLOR 12
    IF LEFT$(COMMAND$, 2) = "/2" THEN
        PRINT "Fatal Error Opening COM2"
    ELSE
        PRINT "Fatal Error Opening COM1"
    END IF
    COLOR 7
    BEEP
    LOCATE 5, 1
    END

GetByteError:
    CLOSE
    COLOR 7
    CLS
    LOCATE 2, 1
    COLOR 12
    PRINT "Fatal Communication Error"
    COLOR 7
    BEEP
    LOCATE 5, 1
    END

LoadError:
    CLOSE #1
    LOCATE 23, 12
    COLOR 12
    PRINT "Error Loading Device Data File - Press Any Key To Continue"
    COLOR 7
    BEEP
    DO
    LOOP UNTIL INKEY$ <> ""
    RESUME MainMenu

SaveError:
    CLOSE #1
    LOCATE 23, 12
    COLOR 12
    PRINT "Error Saving Device Data File - Press Any Key To Continue"
    COLOR 7
    BEEP
    DO
    LOOP UNTIL INKEY$ <> ""
    RESUME MainMenu

Quit:
    LOCATE 23, 30
    COLOR 12
    PRINT " Exit To DOS [Y/N] ? "
    DO
        Key$ = UCASE$(INKEY$)
    LOOP UNTIL Key$ <> ""
    COLOR 7
    SELECT CASE Key$
        CASE "N", CHR$(27)
            LOCATE 23, 30
            PRINT SPACE$(20);
            GOTO MenuLoop
        CASE "Y"
            CLOSE
            CLS
            PRINT
            PRINT "Goodbye!"
            PRINT
            END
    END SELECT
    GOTO Quit

WrongDos:
    PRINT
    PRINT "MS-DOS Version 3.00 or Higher Required"
    PRINT
    END

DosError:
    PRINT
    PRINT "Error Writing to Disk"
    PRINT
    END

Help:
    PRINT
    PRINT
    PRINT "Logic Chip Tester Control Software"
    PRINT "(C) 1994 Paul Stenning and Electronics in Action"
    PRINT
    PRINT
    PRINT "CHIPTEST <Options> <FileName>"
    PRINT
    PRINT "Options"
    PRINT "        /1  =  Use COM1 (default)"
    PRINT "        /2  =  Use COM2"
    PRINT "        /?  =  Display this help information"
    PRINT
    PRINT "FileName  =  Name of device file to load (.CHP extension assumed)"
    PRINT
    PRINT
    END



